#!/bin/bash

	cp /usr/lib/ttn-stack/config/stack/ttn-lw-stack-docker.yml.bak /usr/lib/ttn-stack/config/stack/ttn-lw-stack-docker.yml
	if [[ $1 = updateeth ]]; then
		eval $(ifconfig eth0 | grep inet | grep -v inet6 | awk '{print $2}' | awk -F'.' '{printf("a=%s;b=%s;c=%s;d=%s",$1,$2,$3,$4);}')
		sed 's/10\.130\.2\.18/'$a'\.'$b'\.'$c'\.'$d'/g' /usr/lib/ttn-stack/config/stack/ttn-lw-stack-docker.yml -i;
		hostname="$a.$b.$c.$d"
	elif [[ $1 = updatewlan ]]; then
		eval $(ifconfig wlan0 | grep inet | grep -v inet6 | awk '{print $2}' | awk -F'.' '{printf("a=%s;b=%s;c=%s;d=%s",$1,$2,$3,$4);}')
                sed 's/10\.130\.2\.18/'$a'\.'$b'\.'$c'\.'$d'/g' /usr/lib/ttn-stack/config/stack/ttn-lw-stack-docker.yml -i;
                hostname="$a.$b.$c.$d"
	else

		hostname=$(hostname)
		sed 's/10\.130\.2\.18/'$hostname'/g' /usr/lib/ttn-stack/config/stack/ttn-lw-stack-docker.yml -i;
	fi
               key_32=$(openssl rand -hex 32)
                key_64=$(openssl rand -hex 64)
                sed 's/BLOCKKEY/'$key_32'/g' /usr/lib/ttn-stack/config/stack/ttn-lw-stack-docker.yml -i;
                sed 's/HASHKEY/'$key_64'/g' /usr/lib/ttn-stack/config/stack/ttn-lw-stack-docker.yml -i;


                # docker-compose -f /usr/lib/ttn-stack/docker-compose.yml run --rm stack is-db migrate &> /dev/null


                # if [[ $? != 0 ]]; then
                #        docker-compose -f /usr/lib/ttn-stack/docker-compose.yml run --rm stack is-db init  &> /dev/null
                # fi

                # docker-compose -f /usr/lib/ttn-stack/docker-compose.yml run --rm stack is-db create-admin-user \
                # --id admin \
                # --email ${hostname}@dragino.com \
                # --password dragino &> /dev/null

                docker-compose -f /usr/lib/ttn-stack/docker-compose.yml run --rm stack is-db create-oauth-client \
                --id console \
                --name "Console" \
                --owner admin \
                --secret "console" \
                --redirect-uri "http://${hostname}:8080/console/oauth/callback" \
                --redirect-uri "/console/oauth/callback" \
                --logout-redirect-uri "http://${hostname}:8080/console" \
                --logout-redirect-uri "/console" &> /dev/null

                if [[ $? = 0 ]]; then
                        #       docker-compose -f /usr/lib/ttn-stack/docker-compose.yml up -d
                        systemctl restart ttnstack
                        systemctl enable ttnstack
                fi
