#!/usr/bin/python3

import os
import serial
import sys

commands = ['ATI', 'AT+CSQ', 'AT+CPIN?', 'AT+CGSN', 'AT+COPS?']
output_dir = '/tmp/cell/'

if not os.path.exists(output_dir):
    os.makedirs(output_dir)

ser = serial.Serial('/dev/ttyUSB3', 9600, timeout=None, xonxoff=False, rtscts=False, dsrdtr=False)
ser.flushInput()
ser.flushOutput()

if len(sys.argv) > 1 and sys.argv[1] == 'imei':
    command = 'AT+CGSN'
    ser.write((command + '\r\n').encode('utf-8'))
    response_lines = []
    while True:
        response = ser.readline().strip().decode('utf-8')
        if not response:
            break
        response_lines.append(response)
    if response_lines:
        print(f"{command} Response:")
        for line in response_lines:
            print(line)
        filename = 'IMEI'
        filepath = os.path.join(output_dir, filename)
        with open(filepath, 'w') as f:
            f.write('\n'.join(response_lines))
else:
    for command in commands:
        ser.write((command + '\r\n').encode('utf-8'))
        response_lines = []
        while True:
            response = ser.readline().strip().decode('utf-8')
            if not response:
                break
            response_lines.append(response)
        if response_lines:
            print(f"{command} Response:")
            for line in response_lines:
                print(line)
            filename = command.replace('+', '').replace('?', '')
            filepath = os.path.join(output_dir, filename)
            with open(filepath, 'w') as f:
                f.write('\n'.join(response_lines))