#!/bin/bash

quectel_pid=$(pgrep quectel-CM)
APN=$(uci -q get network.cellular.apn)
Dial_Number=$(uci -q get network.cellular.dialnumber)
Pincode=$(uci get -q network.cellular.pincode)
Username=$(uci get -q network.cellular.username)
Password=$(uci get -q network.cellular.password)
Auth=$(uci -q get network.cellular.auth)
Setting="$APN $Username $Password $Auth"
start()
{
/usr/local/dragino/cell/set_metric.sh &

if [[ ! -z $APN ]] && [[ ! -z $Pincode ]]; then
	/usr/bin/quectel-CM -s $Setting -p $Pincode -f /var/log/qmilog.txt
elif [[ ! -z $APN ]];  then
	/usr/bin/quectel-CM -s $Setting -f /var/log/qmilog.txt
else
	/usr/bin/quectel-CM -f /var/log/qmilog.txt
fi


}

case "$1" in
	start)
		start
		;;
	restart)
		if [ ! -z quectel_pid ]; then
			kill $quectel_pid
		fi
		start
		;;
		
	*)
esac

exit