#!/bin/bash
start()
{
# Initialise mouseovers.
# Mouseovers should be set, cleared, and reset if necessary, for any SAT requiring
# a popup, on every reload of the page. Mouseouts never need to be changed.

###Changelog
###Init scritpt ---------   22/06/22
###Released     ---------   
###
### xiaoye, xiaoye@dragino.cc

mouseover0=''
mouseover1=''
mouseover2=''
mouseover3=''
mouseover4=''
mouseover5=''
mouseover6=''
mouseover7=''
mouseover8=''
mouseover9=''
mouseover10=''
mouseover11=''
mouseover12=''

#Initialise (clear) all SAT images and links

satlink1=""
satlink2=""
satlink3=""
satlink4=""
satlink5=""
satlink6=""
satlink7=""
satlink8=""
satlink9=""
satlink10=""
satlink11=""
satlink12=""

sat1="/static/img/SAT-Space-Blank.png"
sat2="/static/img/SAT-Space-Blank.png"
sat3="/static/img/SAT-Space-Blank.png"
sat4="/static/img/SAT-Space-Blank.png"
sat5="/static/img/SAT-Space-Blank.png"
sat6="/static/img/SAT-Space-Blank.png"
sat7="/static/img/SAT-Space-Blank.png"
sat8="/static/img/SAT-Space-Blank.png"
sat9="/static/img/SAT-Space-Blank.png"
sat10="/static/img/SAT-Space-Blank.png"
sat11="/static/img/SAT-Space-Blank.png"
sat12="/static/img/SAT-Space-Blank.png"


#Hide all SAT images and links - Visibility should be set to "visible" only if there is a (non-blank) image to display.

satvis1="hidden"
satvis2="hidden"
satvis3="hidden"
satvis4="hidden"
satvis5="hidden"
satvis6="hidden"
satvis7="hidden"
satvis8="hidden"
satvis9="hidden"
satvis10="hidden"
satvis11="hidden"
satvis12="hidden"


# Generate the txt files every 10 seconds
while (true); do 

# Get model type
model=$(cat /var/iot/model.txt)

# Get base network config data
cable=$(ifconfig | grep -c eth0)
wireless_mode=$(uci -q get wireless.general.mode)

cell_en=$(uci -q get network.cellular.auto) # Is interface enabled
cell_if=$(ifconfig  | grep -c wwan0) # Is interface present

# Get server type
server_type=$(uci get gateway.general.server_type)

# Get default route
route=$(ip route| grep default | cut -d " " -f 5|grep eth0| awk 'NR==1')

# Check Internet connectivity
internet="$(cat /var/iot/internet)"

##################################
# SAT Display Data

################
# Setup Centre - System
# Nothing to do

################
# Setup SAT1 - WiFi WAN

 satvis1="visible"
 img1="/static/img/SAT-Int-Wifi"
 satlink1="/cgi-bin/system-wifi.has"
 mouseover1='info-1'

wifi_status=$(uci -q get wireless.sta_0.disabled)
wifi_route=$(ip route| grep default | grep wlan0 | cut -d " " -f 5 | awk 'NR==1')
wifi_type=$(uci -q get wireless.general.mode)

# Set up the SAT icon
if [[ $wifi_status = "1" ]] || [[ $wifi_type = "ap" ]]; then
	sat1="/static/img/SAT-Space-Blank.png"
 	mouseover1=""
	satlink1=""
	satvis1="hidden"
elif [[ $wifi_status = "0" ]] &&  [[ $wifi_route = "wlan0" ]]; then
	 sat1=$img1"-tick.png"
else
	sat1=$img1"-cross.png"
fi

################
# Setup SAT2 - Eth WAN

satvis2="visible"
img2="/static/img/SAT-Int-Cable"
satlink2="/cgi-bin/system-network.has"
mouseover2='info-2'

eth_wan=$(ip route | grep default | grep -c  eth0)

# Set up the SAT icon
if [ $internet = "1" ] && [[ $route = "eth0" ]]; then
  sat2=$img2"-tick.png"
elif [[ $eth_wan = "1" ]] && [[ $route != "eth0" ]] ; then
  sat2=$img2"-tick-amber.png"
else
  sat2=$img2"-cross.png"
fi


################
# Setup SAT3 - IoT Service

#	For all the conditions below:
satvis3="visible"

secondary_enable=`uci -q get gateway.server2.provider`
if [[ $secondary_enable = "disable" ]]; then
	mouseover3='info-3'
else
	mouseover3='info-3b'
fi

if [ $server_type = "disabled" ]; then
	satlink3="/cgi-bin/lora-lora.has"
	sat3="/static/img/SAT-Disabled.png"
elif [ $server_type = "lorawan" ]; then
	satlink3="/cgi-bin/lorawan.has"
	status_primary=$(sqlite3 /tmp/lgwdb.sqlite "select * from gwdb" | grep primary | grep online -c)
	status_secondary=$(sqlite3 /tmp/lgwdb.sqlite "select * from gwdb" | grep secondary | grep online -c)
	if [[ $internet = "1" ]];then
		if [[ $status_primary = "1"  ]] || [[ $status_secondary = "1"  ]]; then
			sat3="/static/img/SAT-LoRaWAN-tick.png"	
		else
			sat3="/static/img/SAT-LoRaWAN-cross.png"
		fi
	else
		if [[ $status_primary = "1"  ]] || [[ $status_secondary = "1"  ]]; then
			sat3="/static/img/SAT-LoRaWAN-tick-amber.png"
		else
			sat3="/static/img/SAT-LoRaWAN-cross.png"		
		fi
	fi
elif [ $server_type = "station" ]; then
	satlink3="/cgi-bin/lorawan-basicstation.has"
	station_status=`tail /var/log/station.log | grep -e "HTTP connect failed" -e "failed" -e "Interaction with CUPS failed" -c`
	if [ $station_status = "0" ]; then
		sat3="/static/img/SAT-LoRaWAN-tick.png"
	else
		sat3="/static/img/SAT-LoRaWAN-cross.png"
	fi
else
	sat3=""
  	satlink3=""
  	mouseover3=""
fi

################
# Setup SAT5 - Cellular WAN

satlink5="/cgi-bin/system-cellular.has"

if [ $cell_en = "1" ]; then
	satvis5="visible"
	mouseover5='info-5'
else
	sat5="/static/img/SAT-Space-Blank.png" # No Cell icon reqd if cell not enabled
	mouseover5=''
	satlink5="#"
	satvis5="hidden"
fi

internet_cell=`cat /var/iot/internet`

route_cell=$(ip route| grep default | cut -d " " -f 5 | grep wwan0)

# Set up the SAT icon
if [ $route_cell = "wwan0" ] && [ $internet_cell = "1" ]; then
  sat5="/static/img/SAT-Int-Cell-tick.png"
elif [ $route_cell = "wwan0" ] && [ $internet_cell = "0" ]; then  
  sat5="/static/img/SAT-Int-Cell-cross-amber.png"
elif [ $cell_if = "0" ]; then
	sat5="/static/img/SAT-Int-Cell-cross.png"
elif [ $cell_if = "1" ] && [ $route != "wwan0" ] && [ $internet_cell == "1" ]; then  
  sat5="/static/img/SAT-Int-Cell-tick-amber.png"
elif [ $cell_if = "1" ] && [ $route != "wwan0" ] && [ $internet_cell == "0" ]; then  
  sat5="/static/img/SAT-Int-Cell-cross.png"
fi

################
# Setup SAT10 - LoRa Radios

# TBD  Other status indicator for LoRa radio operation

if [ $server_type = "station" ];then
	pscount=$(pgrep station) # Check is process is running
	satlink10="/cgi-bin/lorawan-aws.has"
	version10=`station -v`
else
	pscount="$(pgrep fwd)" # Check is process is running
	satlink10="/cgi-bin/lora-lora.has"
fi

if [[ -n "$pscount" ]];then
	sat10="/static/img/SAT-LoRa-tick.png"
else
	sat10="/static/img/SAT-LoRa-cross.png"
fi

satvis10="visible"

if [ $server_type = "loriot" ]; then
 	mouseover10='info-10c'
elif [ $server_type = "station" ]; then
	mouseover10='info-10d'
else
 	mouseover10='info-10b'
fi



################
# Setup SAT11 - WiFi Access Point

mouseover11='info-11a'
satlink11="/cgi-bin/system-status.has"
satvis11="visible"

# Check if WiFi channel is displayed to indicate valid operation of AP, with and without WiFi WAN
ap_status=$(ifconfig wlan0 | grep  "10.130.1.1" -c)
if [ "$wireless_mode" = "ap" ] && [ "$ap_status" = "1" ]; then
 	sat11="/static/img/SAT-Wifi-tick.png"
	satlink11="/cgi-bin/system-wifi.has"
else
 	sat11="/static/img/SAT-Wifi-cross.png"
	satlink11="/cgi-bin/system-wifi.has"
fi


if [ "$wireless_mode" != "ap" ]; then
	sat11="/static/img/SAT-Wifi-off.png"
	mouseover11='info-11b'
fi
#########################

# Create the temporary txt file

cat > /tmp/sat-data.txt << EOF

" ",
$sat1,$mouseover1,$satlink1,$satvis1 ,
$sat2,$mouseover2,$satlink2,$satvis2 ,
$sat3,$mouseover3,$satlink3,$satvis3 ,
$sat4,$mouseover4,$satlink4,$satvis4 ,
$sat5,$mouseover5,$satlink5,$satvis5 ,
$sat6,$mouseover6,$satlink6,$satvis6 ,
$sat7,$mouseover7,$satlink7,$satvis7 ,
$sat8,$mouseover8,$satlink8,$satvis8 ,
$sat9,$mouseover9,$satlink9,$satvis9 ,
$sat10,$mouseover10,$satlink10,$satvis10 ,
$sat11,$mouseover11,$satlink11,$satvis11 ,
$sat12,$mouseover12,$satlink12,$satvis12 

EOF
##################################################

# Data collection for info boxes

################
# Centre Data - System

model0=$model
firmware0="$(uci get gateway.general.version)-$(uci get gateway.general.version_date)"
system0=$(cat /etc/os-release | grep PRETTY_NAME| awk -F'"' '{print $2}')
load0=$(uptime | sed -n 's/average:/&\n/;s/.*\n//p')
ip0=$(uci -q get network.lan.ipaddr)

# Info bar data
system_time=$(date)
uptime_str=$(uptime  | cut -d " " -f4,5 | tr , " ")

# ################
# SAT1 Data - WiFi WAN
	info_title1="WiFi Internet"
	ssid1=$(iwconfig wlan0|grep ESSID|awk -F':' '{print$2}')
	ip1=$(ifconfig wlan0 | grep inet | awk 'NR==1' | awk '{print $2}')
	txb1=$(ifconfig wlan0 | grep TX | awk 'NR==1' | awk '{print $6$7}' | sed 's/.//' | sed 's/.$//')
	rxb1=$(ifconfig wlan0 | grep RX | awk 'NR==1' | awk '{print $6$7}' | sed 's/.//' | sed 's/.$//')
	signal1=$( iwconfig wlan0 | grep Signal |awk -F'=' '{print $3}')
	#noise1=$(iwinfo|grep -A 5 wlan0 | grep Signal: | cut -d " " -f 15-17)
	rate1=$(iwlist wlan0 rate | awk -F'=' 'NR==2{print$2}')

###############
# SAT2 Data - Eth WAN

info_title2="Cable Internet"
ip2a=$(ifconfig eth0 | grep "inet" | awk 'NR==1' | awk '{print $2}')
ip2b=$(ifconfig eth0:9|grep "inet addr"|cut -d ":" -f 2|cut -d " " -f 1)
ip2="$ip2a  $ip2b" 
txb2=$(ifconfig eth0 |grep "TX packets"| awk '{print $6$7}' | sed 's/.//' | sed 's/.$//' )
rxb2=$(ifconfig eth0 |grep "RX packets"| awk '{print $6$7}' | sed 's/.//' | sed 's/.$//' )


################
# SAT3 Data - IoT Service

# Get server type
server_type=$(uci get gateway.general.server_type)
# Initialise
process3=" "
status3="0"
server3=" "

	if [ $server_type = "lorawan" ]; then
		info_title3="LoRaWAN Service" 
		
		fwd_process_pid=$(pgrep fwd)

		if [[ ! -z $fwd_process_pid ]]; then
			process3="LoRaWAN process fwd <b>Running</b>"

			if [[ $secondary_enable = "disable" ]]; then
				server3=$(uci get gateway.server1.server_address) 
				if [[ $status_primary = "1" ]]; then
                    status3=Online
					echo "online" > /var/iot/status
                elif [[ $status_primary = "0" ]]; then
                    status3=Offiline
                    echo "offline" > /var/iot/status
                fi
			else
					server_primary3=$(uci get gateway.server1.server_address)
					server_secondary3=$(uci get gateway.server2.server_address) 
					if [[ $status_primary = 1 ]] && [[ $status_secondary = 1 ]]; then
						status_primary3=Online
						status_secondary3=Online
						echo "online" > /var/iot/status
					elif [[ $status_primary = 1 ]] && [[ $status_secondary = 0 ]]; then
						status_primary3=Online
						status_secondary3=Offilne
						echo "primary server online" > /var/iot/status
						echo "secondary server offline" >> /var/iot/status
					elif [[ $status_primary = 0 ]] && [[ $status_secondary = 1 ]]; then
						status_primary3=Offiline
						status_secondary3=Online
						echo "primary server offline" > /var/iot/status
						echo "secondary server online" >> /var/iot/status
					else
						status_secondary3=Offilne
						status_primary3=Offiline
						echo "primary server offline" > /var/iot/status
						echo "secondary server offline" >> /var/iot/stat
					fi
			fi
		else
			process3="LoRaWAN process fwd <b>Not Running</b>"
		fi

	elif [ $server_type = "station" ]; then
		info_title3="AWS-IoT Service"
		server3=`cat /etc/station/cups.uri`
		if [ "`uci get gateway.general.server_type`" = "station" ]; then
		station_status=`tail /var/log/station.log | grep -e "HTTP connect failed" -e "failed" -e "Interaction with CUPS failed" -c`
		if [ $station_status -gt "0" ]; then
			iot_online=0
			echo "offline" > /var/iot/status
		else
			iot_online=1
			echo "online" > /var/iot/status
		fi
		fi

		if [ $station_status = "0" ]; then
			process3="Station is <b>Running</b>"
			status3=$(cat /var/iot/status)
		else
			process3="Station is <b>Not Running</b>"
		fi

fi

################
# SAT5 Data - Cellular WAN

 if [ $cell_en = "1" ]; then
	 info_title5="Cellular Internet"

	ip5=$(ifconfig wwan0 |grep "inet" |grep -v inet6 |awk '{print $2}')
	txb5=$(ifconfig wwan0 |grep "TX packets"|awk '{print $6$7}')
	rxb5=$(ifconfig wwan0 |grep "RX packets"|awk '{print $6$7}')
	
  #  Get cell status and save to file
  # cp /tmp/celltmp.txt /tmp/cell1.txt 
  # killall comgt
  # (comgt -d /dev/ttyModemAT > /tmp/celltmp.txt; ) &
  #rm /tmp/cell_output.txt && touch /tmp/cell_output.txt
  #/usr/local/dragino/cell/getinfo.sh		
  if [ ! -e /tmp/cell/ATI ]; then
	python3 /usr/local/dragino/cell/getinfo.py > /dev/null 2>&1
  fi
	
  # # Extract data for Info box
  sim5=$(cat /tmp/cell/ATCPIN |awk 'NR==3{print$2}')
  sig=$( cat /tmp/cell/ATCSQ |awk 'NR==3{print$2}'|awk -F',' '{print$1}')
  net5=$(cat /tmp/cell/ATCOPS |awk -F',' 'NR==3{print$3,$4}')
  imei5=$(cat /tmp/cell/ATCGSN |awk 'NR==3{print$1}')
  # # Get signal in dBm
  signal=$(echo $sig | cut -d : -f2 | cut -d , -f1)
  if [ $signal -ge "2" ] && [ $signal -le "30" ]; then
  	dbm=$(expr $signal + $signal - "113")
  	sig5="$sig  $dbm dBm" 
	else
		sig5=" $sig"
	fi

  if [ $(ip address show wwan0|grep inet -c) -gt 1 ]; then	
  		internet5="OK"
  else
		internet5="Unable to be assigned an IP address"
  fi
		
 fi

################
# SAT10 Data - LoRa Radios

# Check for LORIOT mode
if [ $server_type = "loriot" ]; then
	info_title10="LORIOT Mode"
	server10="$server3"
elif [ $server_type = "station" ];then
	info_title10="AWS-IoT Core Station"
	server10="$server3"
else
	info_title10="LoRa Radio"
fi

	gwcfg=$(uci get gateway.general.gwcfg)
	subband=$(uci get gateway.general.subband)

	band10=$(grep -e \"$gwcfg\" /var/www/cgi-bin/inc/band.inc | cut -d ">" -f 2 | cut -d "<" -f 1)

	if [ $gwcfg == "AU" ]; then
		subband10=$(grep -e \"$subband\" /var/www/cgi-bin/inc/subband-au.inc | cut -d ">" -f 2 | cut -d " " -f 1,2,3)
	elif [ $gwcfg == "US" ]; then
		subband10=$(grep -e \"$subband\" /var/www/cgi-bin/inc/subband-us.inc | cut -d ">" -f 2 | cut -d " " -f 1,2,3)
	elif [ $gwcfg == "CUS" ]; then
		band10="Custom"
		subband10=" " 
	else
		subband10=" "
	fi
#fi

################
# SAT11 Data - WiFi Access Point
info_title11="WiFi Access point"
ssid11=$(iw dev|grep ssid|awk '{print $2}')
chan11=$(iwlist wlan0 channel | grep channels | awk '{print $2,$3}')
#mode11=$(iwlist wlan0 info | grep "HW Mode" |cut -d : -f 3)
txb11=$(ifconfig wlan0 |grep "TX packets" | awk '{print $6,$7}')
rxb11=$(ifconfig wlan0 |grep "RX packets" | awk '{print $6,$7}')

#######################################

# Create the temporay txt file

cat > /tmp/popup-data.txt << EOF


<div class="info" id="info-0">
	<table>
		<tr>	  <th colspan="2">System Info</th></tr>
		<tr>	  <td>Version:</td><td>$firmware0</td></tr>
		<tr>	  <td>Model:</td><td>$model0 </td>	</tr>
		<tr>	  <td>System:</td><td>$system0 </td>	</tr>
		<tr>	  <td>Load Avg:</td><td>$load0 </td>	</tr>
		<tr>	  <td>Date:</td><td>$system_time </td>	</tr>
		<tr>	  <td>Uptime:</td><td>$uptime_str </td>	</tr>
	</table>
</div>	

<div class="info" id="info-1">
	<table>
	<tr>	  <th colspan="2">$info_title1 </th>	</tr>
	<tr>	  <td>SSID:</td><td>$ssid1 </td>	</tr>
	<tr>	  <td>IP Addr:</td><td>$ip1 </td>	</tr>
	<tr>	  <td>TX Bytes:</td><td>$txb1 </td>	</tr>
	<tr>	  <td>RX Bytes:</td><td>$rxb1 </td>	</tr>
	<tr>	  <td>Signal:</td><td>$signal1 </td>	</tr>
	<tr>	  <td>Bit Rate:</td><td>$rate1 </td>	</tr>
	</table>
</div>	

<div class="info" id="info-2">
	<table>
	<tr>	  <th colspan="2">$info_title2 </th>	</tr>
	<tr>	  <td>IP Addr:</td><td>$ip2 </td>	</tr>
	<tr>	  <td>TX Bytes:</td><td>$txb2 </td>	</tr>
	<tr>	  <td>RX Bytes:</td><td>$rxb2 </td>	</tr>
	</table>
</div>	

<div class="info" id="info-3">
	<table>
	<tr>	  <th colspan="2">$info_title3 </th>	</tr>
	<tr>	  <td>Process:</td><td>$process3 </td>	</tr>
	<tr>	  <td>Status:</td><td>$status3 </td>	</tr>
	<tr>	  <td>Server:</td><td>$server3 </td>	</tr>
	</table>
</div>

<div class="info" id="info-3b">
	<table>
	<tr>	  <th colspan="2">$info_title3 </th>	</tr>
	<tr>	  <td>Process:</td><td>$process3 </td>	</tr>
	<tr>	  <td>Server Primary:</td><td>$server_primary3 </td>	</tr>
	<tr>	  <td>Status:</td><td>$status_primary3 </td>	</tr>
	<tr>	  <td>Server Secondary:</td><td>$server_secondary3 </td>	</tr>
	<tr>	  <td>Status:</td><td>$status_secondary3 </td>	</tr>
	</table>
</div>	

<div class="info" id="info-3a">
	<table>
	<tr>	  <th colspan="2">$info_title3 </th>	</tr>
	<tr>	  <td>Process:</td><td>$process3 </td>	</tr>
	<tr>	  <td>Ver:</td><td>$version3 </td>	</tr>
	<tr>	  <td>Server:</td><td>$server3 </td>	</tr>
	</table>
</div>	

<div class="info" id="info-5">
	<table>
	<tr>	  <th colspan="2">$info_title5 </th>	</tr>
	<tr>	  <td>IP Addr:</td><td>$ip5 </td>	</tr>
	<tr>	  <td>TX Bytes:</td><td>$txb5 </td>	</tr>
	<tr>	  <td>RX Bytes:</td><td>$rxb5 </td>	</tr>
	<tr>	  <td>SIM:</td><td>$sim5 </td>	</tr>
	<tr>	  <td>Network:</td><td>$net5 </td>	</tr>
	<tr>	  <td>Signal:</td><td>$sig5 </td>	</tr>
	<tr>	  <td>IMEI:</td><td>$imei5 </td>	</tr>
	<tr>	  <td>Internet:</td><td><b>$internet5</b></td>	</tr>
	</table>
</div>	

<div class="info" id="info-10a">
	<table>
		<tr>	  <th colspan="2">$info_title10 </th>	</tr>
		<tr>	  <td>Rx Freq:</td><td>$rxfreq10 </td>	</tr>
		<tr>	  <td>Tx Freq:</td><td>$txfreq10 </td>	</tr>
		<tr>	  <td>Rx BW / CR / SF:</td><td>$rxbw10 / $rxcr10 / $rxsf10 </td>	</tr>
		<tr>	  <td>Tx BW / CR / SF:</td><td>$txbw10 / $txcr10 / $txsf10 </td>	</tr>
	</table>
	</div>	

<div class="info" id="info-10b">
	<table>
		<tr>	  <th colspan="2">$info_title10 </th>	</tr>
		<tr>	  <td>Freq Band:</td><td>$band10</td>	</tr>
		<tr>	  <td>Sub Band:</td><td>$subband10</td>	</tr>
	</table>
	</div>	

<div class="info" id="info-10c">
	<table>
		<tr>	  <th colspan="2">$info_title10 </th>	</tr>
		<tr>	  <td>Server:</td><td>$server10</td>	</tr>
	</table>
</div>	

<div class="info" id="info-10d">
	<table>
		<tr>	  <th colspan="2">$info_title10 </th>	</tr>
		<tr>	  <td>Version:</td><td>$version10</td>	</tr>
	</table>
</div>

<div class="info" id="info-11a">
	<table>
	<tr>	  <th colspan="2">$info_title11 </th>	</tr>
	<tr>	  <td>SSID:</td><td>$ssid11 </td>	</tr>
	<tr>	  <td>Channel:</td><td>$chan11 </td>	</tr>
	<tr>	  <td>LAN address:</td><td>10.130.1.1 </td>	</tr>
	<tr>	  <td>TX Bytes:</td><td>$txb11 </td>	</tr>
	<tr>	  <td>RX Bytes:</td><td>$rxb11 </td>	</tr>
	</table>
</div>	

<div class="info" id="info-11b">
	<table>
	<tr>	  <th colspan="2">$info_title11 </th>	</tr>
	<tr>	  <td>State:</td><td>Disable </td>	</tr>
	</table>
</div>	
|||$system_time|||$uptime_str

EOF
#####################

sleep 9; \
done &
} >/dev/null 2>&1    # dump unwanted output to avoid filling log

case "$1" in
	start)
		start
		;;
	stop)
		stop
		;;
	*)
esac

exit

